%Made by J.T.B. Overvelde on 9 may 2011

function [u,v,p]=PresProj(x,y,uStar,vStar,A,f)

global rho mu g dt nX nY nXp nYp w h boundU boundV boundP N hx hy

%inner cells A and right hand side vector
for i=2:nXp-1
    for j=2:nYp-1
        f(N(i,j))=f(N(i,j))+1/2*(uStar(i,j)-uStar(i-1,j)+uStar(i,j-1)-uStar(i-1,j-1))/hx+...
                  1/2*(vStar(i,j)-vStar(i,j-1)+vStar(i-1,j)-vStar(i-1,j-1))/hy;
    end
end

%don't take into account corners 
corner=[1 nXp nXp*nYp-nXp+1 nXp*nYp];
fixed = logical(zeros(1,nXp*nYp));
fixed(corner)= 1;
free = ~fixed;

%solve pressure equation
pt=sparse(nXp*nYp,1);
pt(free)=A(free,free)\f(free);
p=zeros(nXp,nYp);
for i=1:nXp
    for j=1:nYp
        p(i,j)=pt(N(i,j));
    end
end

%calculate new u, v
u(2:nX-1,2:nY-1) = uStar(2:nX-1,2:nY-1) - dt/(2*rho*hx)*(p(3:nX,3:nY)-p(2:nX-1,3:nY)+p(3:nX,2:nY-1)-p(2:nX-1,2:nY-1));
v(2:nX-1,2:nY-1) = vStar(2:nX-1,2:nY-1) - dt/(2*rho*hy)*(p(3:nX,3:nY)-p(3:nX,2:nY-1)+p(2:nX-1,3:nY)-p(2:nX-1,2:nY-1));

% boundary conditions
for i=1:4
        u = boundaryConditions(u,boundU(i,1),boundU(i,2),boundU(i,3));
        v = boundaryConditions(v,boundV(i,1),boundV(i,2),boundV(i,3));
end





