%Made by J.T.B. Overvelde on 9 may 2011

function [A,f]=PresProjInit()

global rho mu g dt nX nY nXp nYp w h boundU boundV boundP N split hx hy

%cell matrix and force vector
A=sparse(nXp*nYp);
f=sparse(nXp*nYp,1);

%inner cells A and right hand side vector
for i=2:nXp-1
    for j=2:nYp-1
        A(N(i,j),N(i-1,j))=dt/rho/hx^2;
        A(N(i,j),N(i+1,j))=dt/rho/hx^2;
        A(N(i,j),N(i,j))=-2*dt/rho/hx^2-2*dt/rho/hy^2;
        A(N(i,j),N(i,j-1))=dt/rho/hy^2;
        A(N(i,j),N(i,j+1))=dt/rho/hy^2;
    end
end

%boundary conditions
%right boundary
i=nXp;
for j=2:nYp-1
    if boundP(boundP(:,1)==1,2)==1
        A(N(i,j),[N(i,j)])=[1];
        f(N(i,j))=boundP(boundP(:,1)==1,3);
    elseif boundP(boundP(:,1)==1,2)==2
        A(N(i,j),[N(i,j) N(i+1,j)])=[1 -1];
    end
end
%left boundary
i=1;
for j=2:nYp-1
    if boundP(boundP(:,1)==2,2)==1
        A(N(i,j),[N(i,j)])=[1];
        f(N(i,j))=boundP(boundP(:,1)==2,3);
    elseif boundP(boundP(:,1)==2,2)==2
        A(N(i,j),[N(i,j) N(i+1,j)])=[1 -1];
    end
end
%lower boundary
j=1;
for i=2:nXp-1
    if boundP(boundP(:,1)==3,2)==1
        A(N(i,j),[N(i,j)])=[1];
        f(N(i,j))=boundP(boundP(:,1)==3,3);
    elseif boundP(boundP(:,1)==3,2)==2
        A(N(i,j),[N(i,j) N(i+1,j)])=[1 -1];
    end
end
%upper boundary
j=nYp;
for i=2:nXp-1
    if boundP(boundP(:,1)==4,2)==1
        A(N(i,j),[N(i,j)])=[1];
        f(N(i,j))=boundP(boundP(:,1)==4,3);
    elseif boundP(boundP(:,1)==4,2)==2
        A(N(i,j),[N(i,j) N(i+1,j)])=[1 -1];
    end
end




